<?php

namespace Ecommerce\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Doctrine\ORM\EntityManager;
use PHPExcel_IOFactory;

class UserInfoController {
    
    protected $dataSourceName;
    protected $parameterBagColumns;
    protected $connection;
    protected $userInfoService;
    protected $dataSourceManager;
    protected $zhFileUploader;
    protected $fileServerURL;
    protected $entityManager;
    protected $imgPathURL;
    protected $uploadRoutes;
    
    
    public function __construct($environment, $crudService, $userInfoService, $connection, $dataSourceManager, $zhFileUploader, $fileServerURL, EntityManager $entityManager, $imgPathURL, $uploadRoutes) {
	
		$this->crudService  = $crudService;
		$this->environment  = $environment;
        $this->UserInfoService  = $userInfoService;
        $this->connection   = $connection;
        $this->dataSourceManager = $dataSourceManager;
        $this->zhFileUploader    = $zhFileUploader;
        $this->fileServerURL     = $fileServerURL;
        $this->entityManager = $entityManager;
        $this->imgPathURL = $imgPathURL;
        $this->uploadRoutes     = $uploadRoutes;
        
	}
	
     public function saveLogoSupplier(DTO\Request $request, DTO\Response $response) {
		$row = $request->getRow();
		try {
            $this->entityManager->beginTransaction();
		    if($row['FOTOLOGO'] != null){
    	        $fileRow['UPLOAD_AUT_IMAGE'][0] = [
                    'b64File'            => $row["IMAGE_UPLOAD"][0]["b64File"],
                    "name"               => $row["IMAGE_UPLOAD"][0]["name"],
                    'type'               => $row["IMAGE_UPLOAD"][0]["type"],
                    'webkitRelativePath' => '',
                    'size'               => ''
                ];
    	        $this->zhFileUploader->uploadFilesInRow($fileRow, $this->uploadRoutes['/savePhotosAutomatic']['fileField'], $this->uploadRoutes['/savePhotosAutomatic']['customFolder'] . '/' . $row['CDFORNECED']);
    	        $row["DSFOTOFORNFILESERV"] = $fileRow['UPLOAD_AUT_IMAGE']["0"]["path"];
    	        $fotoLogo = $this->imgPathURL.$row["DSFOTOFORNFILESERV"];
	        }else{
		        $row["DSFOTOFORNFILESERV"] = null;
    		    $fotoLogo = $row['FOTOLOGO'];
		    }
    		$this->UserInfoService->saveLogoSupplier($row);
    		$dataset = array(
                "PATHIMAGE"   => $fotoLogo
            );
            $response->addDataSet(new DataSet('data', $dataset));
		    $this->entityManager->commit();
        } catch (\Exception $e){
            $this->entityManager->rollBack();
            throw $e;
        }
	}
	
	public function userInfo(DTO\Request $request, DTO\Response $response) {
		$filterCriteria = $request->getFilterCriteria();
		$filterCriteria->setDataSourceName("userInfo");
		$filterCriteria = $this->crudService->getFilterCriteriaWithNrOrg($filterCriteria);
		$newFilterCriteria = $this->crudService->getPopulatedFilterCriteria($filterCriteria, array());
		$dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
		$newDataSet = $this->setImgFullPath($dataSet);
        $response->addDataSet($newDataSet);
	}
	
	private function setImgFullPath($dataSet) {
	   
		$rows = $dataSet->getRows();
		foreach ($rows as &$row) {
			if ($row["FOTOLOGO"] !== null) {
				$row["FOTOLOGO"] = $this->imgPathURL.$row["FOTOLOGO"];
			}
		}
		return new DataSet("userInfo", $rows);
	}
}